--
-- Manfredas Zabarauskas
-- University of Edinburgh
-- BSc Artificial Intelligence & Computer Science '08
--
-- Informatics 1A Competition Entry
--
-- PPM.hs
--

module PPM (
            convertToPPM    -- Bitmap -> String
            )
       where

import Array

import Render

convertToPPM :: Bitmap ->  -- input bitmap
                String     -- resulting PPM char sequence
convertToPPM bmp = "P3\n" ++ (show (width + 1)) ++ " " ++ (show (height + 1)) ++ " 255\n" ++ 
                   concat [clrToStr (bmp ! (x, y)) | y <- [height, height-1..0], x <- [0..width]]
    where clrToStr (r, g, b) = (show r) ++ " " ++ 
                               (show g) ++ " " ++ 
                               (show b) ++ "\n"
          ((x0, y0), (x1, y1)) = bounds bmp
          width = x1
          height = y1
